#!/bin/bash
# script permettant la sync de sysvol, lancé sur les DC.
# resync les id si besoin, et copie sysvol et remet les bons acls.
#
# $config_se4ad_name doit correspondre à l'AD ayant le role de controleur de réplication
#
# un param rsync_secret doit être présent dans sambaedu.conf
#
# lancé par cron, ou à la demande
#
. /usr/share/sambaedu/includes/config.inc.sh
. /usr/share/sambaedu/includes/ad.inc.sh
. /usr/share/sambaedu/includes/utils.inc.sh
my_network
if [ "$my_address" == "$config_se4ad_ip" ]; then
    tdbbackup -s .bak /var/lib/samba/private/idmap.ldb
#   scp -i /etc/sambaedu/id_rsa /var/lib/samba/private/idmap.ldb.bak root@${config_se4ad_slave_ip}:/var/lib/samba/private/
#   ssh -i /etc/sambaedu/id_rsa root@${config_se4ad_slave_ip} cp /var/lib/samba/private/idmap.ldb.bak /var/lib/samba/private/idmap.ldb
#   ssh -i /etc/sambaedu/id_rsa root@${config_se4ad_slave_ip} net cache flush
#   rsync -e "ssh -i /etc/sambaedu/id_rsa" -aP /var/lib/samba/sysvol/ root@${config_se4ad_slave_ip}:/var/lib/samba/sysvol/
#   ssh -i /etc/sambaedu/id_rsa root@${config_se4ad_slave_ip} samba-tool ntacl sysvolreset -U$config_ldap_admin_name --password="$config_ldap_admin_passwd"
    echo "sysvol-replication:$config_rsync_secret" > /etc/sambaedu/rsyncd.secret
    chmod 600 /etc/sambaedu/rsyncd.secret
elif [ "$my_address" == "$config_se4ad_etab_ip" -o "$my_address" == "$config_se4ad_slave_ip" ] && [ -n "$config_rsync_secret" ]; then
    echo $config_rsync_secret > /etc/sambaedu/rsync.secret
    chmod 600 /etc/sambaedu/rsync.secret
    id=$(rsync -c --stats --password-file=/etc/sambaedu/rsync.secret rsync://sysvol-replication@$config_se4ad_name/Private/idmap.ldb.bak /var/lib/samba/private/ | grep "Number of reg" | cut -d" " -f 6)
    if [ "$id" -gt 0 ]; then
        cp /var/lib/samba/private/idmap.ldb.bak /var/lib/samba/private/idmap.ldb
        net cache flush
        echo "Synchro idmap"
    fi
    nb=$(rsync -XAavz --stats --delete-after --password-file=/etc/sambaedu/rsync.secret rsync://sysvol-replication@$config_se4ad_name/SysVol/ /var/lib/samba/sysvol/ | grep "Number of reg" | cut -d" " -f 6)
    if [ "$nb" -gt 0 -o "$id" -gt 0 ]; then
        samba-tool ntacl sysvolreset
        echo "Synchro Sysvol : $nb fichiers modifiés"
    fi
fi
